<template>
  <li class="nav-item">
    <b-link @click.native="onClick" class="nav-link"
      :to="href" :exact="exact" :role="role" :aria-label="`Go to ${label} page`">
      <icon v-if="icon" :name="icon" :square="20" :stroke-width="2"/>
      <span>{{ label }}</span>
    </b-link>

    <slot></slot>
  </li>
</template>

<script>
export default {
  name: 'sidebar-menu',

  props: {
    name: {
      type: String
    },

    href: {
      type: String
    },

    label: {
      type: String
    },

    icon: {
      type: String,
      default: ''
    },

    exact: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    hasChildren () {
      return Array.isArray(this.$slots.default)
    },

    role () {
      return this.hasChildren ? 'tab' : 'menuitem'
    }
  },

  methods: {
    onClick (e) {
      this.$emit('click', e)
    }
  }
}
</script>

<style lang="scss" scoped>
.nav-link {
  padding-top: 8px;
  padding-bottom: 8px;
  color: $gray-600;
  position: relative;
  user-select: none;
  font-weight: $font-weight-bold;
  border-right: 5px solid transparent;
  line-height: 24px;

  &.active {
    color: $primary;
    cursor: initial;
  }

  > .icon {
    margin-right: 10px;
    vertical-align: top;
    line-height: 1.4;
  }
}

.nav-item {
  position: relative;
  width: 100%;
  display: block;

  .nav-link:hover {
    background-color: $gray-200;
  }

  &.has-subs > .nav-link::after {
    content: '';
    position: absolute;
    top: 40%;
    right: 1rem;
    border-top: 0.3em solid;
    border-right: 0.3em solid transparent;
    border-bottom: 0;
    border-left: 0.3em solid transparent;
  }

  &.opened {
    // background-color: $white;

    > .nav-link::after {
      transform: rotate(180deg);
    }
  }

  &:not(.opened) > .active {
    border-right-color: $primary;
    background-color: $gray-100;
  }
}
</style>
